#include <bits/stdc++.h>

using namespace std;


int stepenDvojke(int n)
{
    int p = 1;
    while(p <= n)
    {
        p <<= 1;
    }
    if(p > n)
    {
        p >>= 1;
    }
    return p;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int N, Q;
    cin >> N >> Q;
    int x, y;
    int A[N];
    for(int i = 0; i < N; i++)
    {
        cin >> A[i];
        A[i] = stepenDvojke(A[i]);
    }
    for(int e = 0; e < Q; e++)
    {
        int r, l;
        cin >> r >> l;
        int B[N];
        for(int i = 0; i < N; i++)
        {
            B[i] = A[i];
        }
        sort(B, B + N);
        int k = 1, kmax = 0;
        while(r <= l)
        {
            if(B[r] == B[r-1])
            {
                k++;
            }
            else
            {
                if(kmax < k)
                {
                    kmax = k;
                }
                k = 1;
            }
            r++;
        }
        cout << kmax << '\n';
    }
    /*
    5 3
1 2 1 3 2
1 5
1 4
2 3
*/
}